# Tragic: L'accozzaglia
Progetto finale Programmazione Procedurale con Laboratorio a.a. 2021/2022.


__Nome: Amedeo__

__Cognome: Di Biase__


## Note di implementazione
- La deallocazione della memoria dinamica è stata inserita in una funzione richiamabile alla fine di ogni incontro per reimpostare i valori iniziali dei maghi.
- A differenza della consegna per il combattimento è stata creata una funzione aggiuntiva, per migliorare la modularità del programma.
- La creazione del personaggio (inserimento nickname e classe mago) è stata spostata in una funzione sempre per migliorare la modularità del programma.
- All'utente è stata assegnata la possibilità di stampare o meno i mazzi durante l'impostazione del torneo, dato che potrebbero occupare molto spazio sullo schermo.
- Per migliorare l'esperienza utente gli enum riguardanti il tipo della carta e la classe del mago non sono stati stampati come interi, bensì è stata creata una funzione apposita che restituisce il nome del dato richiesto.
- Per rendere l'output dei mazzi più compatto verticalmente, essi vengono stampati in due colonne.
- Nel torneo per tener traccia dei sfidanti che hanno passato il turno sono state create delle nuove variabili stringa in cui mantenere il Nickname dei vincitori.
- Sono stati aggiunti messaggi di notifica e di errore in caso l'utente inserisca in input un valore inaspettato.
- Se uno sfidante decide di giocare una carta viene automaticamente stampata la sua mano.
- Per evitare softlock in particolari casi, se si decide di giocare una determinata carta ma non ci sono bersagli su cui giocarla, la carta viene distrutta. <br> Ad esempio se durante la generazione del mazzo le ultime sei carte fossero tutte "Rimuovi Creatura", il mago non potrebbe giocare fino a quando l'avversario non gioca una creatura.

## Estensioni del progetto
- Per l'estetica è stato aggiunto un logo in codice ANSI e successivamente convertito in codice colori C (E.g.: \e[48;5;15m -> \033[107m per il colore bianco).
- È stato fornito alle carte un nome ed un aggettivo per renderle più riconoscibili e per migliorare l'esperienza utente.
- Sono stati dichiarati due array, uno con dei nomi e uno con degli aggettivi. Per generare il nome viene scelto un elemento casuale da entrambi gli array.
- È stata aggiunta una funzione di torneo da 4 o 8 giocatori per giocare con gli amici o in famiglia. Il numero di giocatori non può essere diverso da 4 o 8 in quanto non sono stati previsti gironi con numero di partecipanti dispari.
- Sono stati aggiunti diversi flag per il controllo delle impostazioni, quali:
	1) Un controllo se il gioco è stato già impostato in precedenza;
	2) Il numero di giocatori, permettendo un comportamento del programma diverso nel caso del torneo torneo;
	3) Il controllo se è stato scelto un semplice duello oppure il torneo, sempre per far assumere un comportamento diverso al programma.
- È stata aggiunta una modalità Battle Royale scaricabile nella [versione completa](https://tragic.altervista.org) a causa di limitazioni del linguaggio C nella gestione delle informazioni di 100 giocatori (Disclaimer: Non scientificamente testato).

